﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using Infragistics.Samples.Data.Models.Series;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        List<SeriesInfo> OriginalSet = new List<SeriesInfo>();

        public MainPage()
        {
            InitializeComponent();
            Loaded += MainPage_Loaded;
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            foreach (var fragseries in (DataChart.Series[0] as StackedColumnSeries).Series)
                OriginalSet.Add(new SeriesInfo { Series = fragseries, Visibility = System.Windows.Visibility.Visible });
        }

        private void MyLegend_LegendItemMouseLeftButtonUp(object sender, Infragistics.Controls.Charts.DataChartLegendMouseButtonEventArgs e)
        {
            StackedColumnSeries series = DataChart.Series[0] as StackedColumnSeries;
            int seriesIndex = (e.Series as ColumnFragment).Index;
            //int index = e.Series.ItemsSource.Cast<EnergyProduction>().ToList().IndexOf(e.Item as EnergyProduction);

            if (OriginalSet[seriesIndex].Visibility == System.Windows.Visibility.Collapsed)
            {
                // Add back the series.
                series.Series.Add(OriginalSet[seriesIndex].Series);
                OriginalSet[seriesIndex].Visibility = System.Windows.Visibility.Visible;
            }
            else
            {
                series.Series.Remove(OriginalSet[seriesIndex].Series);
                OriginalSet[seriesIndex].Visibility = System.Windows.Visibility.Collapsed;
            }
        }
    }

    public class SeriesInfo
    {
        public StackedFragmentSeries Series { get; set; }

        public Visibility Visibility { get; set; }
    }
}
